
MAKEFLAGS += r
# Prevents attempts to regard .mod files as modula-2 and using m2c to compile
# them into .c files:
%.o : %.mod 

#===== Compilers =================================================================
CC=gcc

# Pick one of ifort or gfortran
# F90=ifort
F90=gfortran
F95=$(F90)

#===== Optimizations =============================================================

# ifeq (F95,"gfortran")       # does not work, even with $(F90) and no ws in F90 
ifeq "$(strip $(F95))" "gfortran"
	OPTS = \
	-O3 \
	-fdiagnostics-color=auto  \
	-Wconversion-extra \
	-Warray-temporaries \
	-fcheck-array-temporaries \
	-ftree-vectorize \
	-fopenmp \
	-funroll-loops \
	--param max-unroll-times=4 \
	-ffast-math \
	-std=f2008 \
	-ffp-contract=fast \
	-march=native \
	-fno-range-check \
	-ffpe-trap=underflow
	# You may need to delete the last option, if underflow occurs.


else
	OPTS = -O3     \
    -opt-prefetch   \
    -align all      \
    -ccdefault none \
    -ftz            \
    -funroll-loops  \
    -falign-functions=16 \
    -fp-model fast=2 \
    -fp-speculation=fast \
    -opt-prefetch \
    -no-prec-div \
    -xHost \
	-assume realloc_lhs \
	-assume protect_parens \
	-openmp 	

endif

CCOPTS = -O3

# Make sure that any build knows which targets are not files
.PHONY: install clean kleen


#===== Libraries and Other Effluvia ==============================================

# Use the 2013 Intel libs:
MKLROOT = /opt/intel/composer_xe_2013.3.163/mkl
LIBS =   -L$(MKLROOT)/lib/intel64 -lmkl_rt -lpthread -lm
# add -lgomp for OpenMP

